SystemOrganization addCategory: #'EjerciciosPoo-Measure'!

Magnitude subclass: #Measure
	instanceVariableNames: 'amount unit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!Measure class methodsFor: 'instance-creation' stamp: 'SebastianGarbi 5/20/2013 20:53'!
newAmount: unNumero unit: unaUnidadDeMedida 
	^self new amount: unNumero unit: unaUnidadDeMedida.! !

!Measure methodsFor: 'arithmetic' stamp: 'SebastianGarbi 5/26/2013 19:51'!
* aMeasureOrScalar

	(aMeasureOrScalar isKindOf: self class)
		ifTrue: [
"			aMeasure := aMeasureOrScalar convertToBase.
			selfBase := self convertToBase."
			^(self amount * aMeasureOrScalar amount) * (self unit * aMeasureOrScalar unit)
			].
	^self rescaleDoing: [ :aNumber | aNumber * aMeasureOrScalar ].! !

!Measure methodsFor: 'arithmetic' stamp: 'SebastianGarbi 5/22/2013 18:16'!
+ aDistance 
	"^Distance newAmount: (self amount + (aDistance amountInUnit: self unit))  
	unit: self unit."
	^self rescaleDoing: [ :aNumber | aNumber +  (aDistance amountInUnit: self unit) ].! !

!Measure methodsFor: 'arithmetic' stamp: 'SebastianGarbi 5/22/2013 18:16'!
- aDistance 
	"^Distance newAmount: (self amount + ((aDistance amountInUnit: self unit)*(-1)) )  
	unit: self unit."
	"^self rescaleDoing: [ :aNumber | aNumber - (aDistance amountInUnit: self unit) ]."
	^self + aDistance negated .! !

!Measure methodsFor: 'arithmetic' stamp: 'SebastianGarbi 5/26/2013 23:07'!
/ aMeasureOrScalar
	"^Distance newAmount: (self amount / (aNumber) )  
	unit: self unit."
	(aMeasureOrScalar isKindOf: self class)
		ifTrue: [
			(self unit = aMeasureOrScalar unit) ifTrue: 
			[ ^self amount / aMeasureOrScalar amount ]
		ifFalse: 
			[ 
				^Measure newAmount: self amount / aMeasureOrScalar amount  unit: self unit / aMeasureOrScalar unit 
			].
		].
	^self * (1 / aMeasureOrScalar ).! !

!Measure methodsFor: 'comparing' stamp: 'SebastianGarbi 5/22/2013 21:28'!
< aMeasure 
	^(self amount < (aMeasure amountInUnit: self unit) ).! !

!Measure methodsFor: 'comparing' stamp: 'SebastianGarbi 5/26/2013 21:03'!
= aMeasure
	[ ^ (aMeasure isKindOf: self class) and: 
		((self unit canBeConvertedTo: aMeasure unit) and:
		(self amount = (aMeasure amountInUnit: self unit )))
	]
		on: Error
		do: [
			[^ (aMeasure isKindOf: self class) and: (self isZero and: aMeasure isZero)]
			on: Error
			do:[^false].
			].
! !

!Measure methodsFor: 'accessing' stamp: 'SebastianGarbi 5/20/2013 21:11'!
amount
	^ amount! !

!Measure methodsFor: 'instance creation' stamp: 'SebastianGarbi 5/20/2013 20:54'!
amount: unNumero unit: unaUnidadDeMedida
	amount := unNumero.
	unit := unaUnidadDeMedida.
	^self.! !

!Measure methodsFor: 'private' stamp: 'SebastianGarbi 5/20/2013 21:14'!
amountInUnit: aUnit 
	^(self convertTo: aUnit) amount! !

!Measure methodsFor: 'converting' stamp: 'SebastianGarbi 5/25/2013 13:42'!
convertTo: unaUnidadDeMedida 
	(unaUnidadDeMedida isKindOf:  self unit class) ifFalse: [ ^ CanNotConvertMeasurement signal ].
	^self  class newAmount:  (unaUnidadDeMedida fromBase value: (self unit toBase value: self amount)) unit: unaUnidadDeMedida.! !

!Measure methodsFor: 'hash' stamp: 'SebastianGarbi 5/22/2013 20:15'!
hash 
	"^(self amountInUnit: DistanceUnit meter) hash"
	^(self amountInUnit: (self unit class baseUnit)) hash! !

!Measure methodsFor: 'comparing' stamp: 'SebastianGarbi 5/26/2013 20:50'!
isZero
	| nothing |
	nothing := self unit class nothing.
	^(self amountInUnit: nothing unit) =  nothing amount.
! !

!Measure methodsFor: 'arithmetic' stamp: 'SebastianGarbi 5/25/2013 13:53'!
negated
	"^Distance newAmount: (self amount * (-1)) 
	unit: self unit. "
	^self rescaleDoing: [ :aNumber | aNumber negated].! !

!Measure methodsFor: 'printing' stamp: 'SebastianGarbi 5/22/2013 21:19'!
printString
	(self unit = TemperatureUnit celsius)
		ifTrue: [^(self amount printString ), ' ', (self unit printString)]
		ifFalse:[	^(self amount printString ), ' ', (self unit printString asPluralBasedOn: self amount )].! !

!Measure methodsFor: 'private' stamp: 'SebastianGarbi 5/22/2013 21:23'!
rescaleDoing: aBlock
	^self class newAmount: (aBlock value: (self amount))  unit: self unit.! !

!Measure methodsFor: 'enumerating' stamp: 'SebastianGarbi 5/25/2013 13:54'!
to: aMeasure 
	^MeasureInterval newFrom: self to: aMeasure by: (1*self unit).! !

!Measure methodsFor: 'enumerating' stamp: 'SebastianGarbi 5/22/2013 23:28'!
to: aMeasure by: anIncrementMeasure 
	^MeasureInterval newFrom: self to: aMeasure  by: anIncrementMeasure . ! !

!Measure methodsFor: 'accessing' stamp: 'SebastianGarbi 5/20/2013 21:11'!
unit
	^ unit! !

TestCase subclass: #MeasureTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!MeasureTest methodsFor: 'errors' stamp: 'SebastianGarbi 5/25/2013 13:34'!
canNotConvertMeasurementException
	
	^ CanNotConvertMeasurement .
	
	"self error: 'Este metodo debe devolver el objeto que representa que no se pudo
		convertir una medida a la unidad pedida'"! !

!MeasureTest methodsFor: 'temperature units' stamp: 'SebastianGarbi 5/22/2013 18:28'!
celsius
	^ TemperatureUnit celsius! !

!MeasureTest methodsFor: 'distance units' stamp: 'SebastianGarbi 5/22/2013 18:26'!
centimeter
	^ DistanceUnit centimeter! !

!MeasureTest methodsFor: 'time units' stamp: 'SebastianGarbi 5/22/2013 18:32'!
day
	^ TimeUnit day! !

!MeasureTest methodsFor: 'distance units' stamp: 'SebastianGarbi 5/22/2013 18:26'!
decameter
	^ DistanceUnit decameter! !

!MeasureTest methodsFor: 'distance units' stamp: 'SebastianGarbi 5/22/2013 18:26'!
decimeter
	^ DistanceUnit decimeter! !

!MeasureTest methodsFor: 'distance measures' stamp: 'HernanWilkinson 4/25/2011 17:27'!
distanceExamples 

	^self objectsInCategoryOf: thisContext method selector.
	
! !

!MeasureTest methodsFor: 'distance units' stamp: 'HernanWilkinson 4/25/2011 17:27'!
distanceUnits 

	^self objectsInCategoryOf: thisContext method selector.
	
! !

!MeasureTest methodsFor: 'compound measures' stamp: 'SebastianGarbi 5/26/2013 19:32'!
eightCubicMeters
	^8*(self meter * self meter * self meter)
! !

!MeasureTest methodsFor: 'temperature units' stamp: 'SebastianGarbi 5/22/2013 18:28'!
fahrenheit
	^ TemperatureUnit fahrenheit! !

!MeasureTest methodsFor: 'compound measures' stamp: 'SebastianGarbi 5/26/2013 23:22'!
finalSpeedStartingAt: initialSpeed accelerating: anAcceleration during: aTimePeriod
	^initialSpeed + (anAcceleration * aTimePeriod ).
	"^self error: 'Implementar la formula de velocidad final: vf = vi + a * t'"! !

!MeasureTest methodsFor: 'compound measures' stamp: 'SebastianGarbi 5/26/2013 19:31'!
fourSquaredMeters
	^4*(self meter * self meter)
! !

!MeasureTest methodsFor: 'distance units' stamp: 'SebastianGarbi 5/22/2013 18:26'!
hectometer
	^ DistanceUnit hectometer! !

!MeasureTest methodsFor: 'time units' stamp: 'SebastianGarbi 5/22/2013 18:32'!
hour
	^ TimeUnit hour! !

!MeasureTest methodsFor: 'temperature units' stamp: 'SebastianGarbi 5/22/2013 18:29'!
kelvin
	^ TemperatureUnit kelvin! !

!MeasureTest methodsFor: 'distance units' stamp: 'SebastianGarbi 5/22/2013 18:26'!
kilometer
	^ DistanceUnit kilometer! !

!MeasureTest methodsFor: 'objects in category' stamp: 'HernanWilkinson 4/25/2011 17:30'!
measureExamples 

	^ OrderedCollection new
		addAll: self distanceExamples;
		addAll: self temperatureExamples;
		addAll: self timeExamples;
		yourself ! !

!MeasureTest methodsFor: 'distance units' stamp: 'SebastianGarbi 5/22/2013 18:27'!
meter
	^ DistanceUnit meter! !

!MeasureTest methodsFor: 'distance units' stamp: 'SebastianGarbi 5/22/2013 18:27'!
millimeter
	^ DistanceUnit millimeter! !

!MeasureTest methodsFor: 'distance measures' stamp: 'SebastianGarbi 5/25/2013 13:30'!
minusOneMeter
	^-1*self meter.! !

!MeasureTest methodsFor: 'time units' stamp: 'SebastianGarbi 5/22/2013 18:32'!
minute
	^ TimeUnit minute! !

!MeasureTest methodsFor: 'objects in category' stamp: 'HernanWilkinson 4/25/2011 17:27'!
objectsInCategoryOf: aSelector

	| category messageNames |
	
	category := self class organization categoryOfElement: aSelector.
	messageNames := (self class organization listAtCategoryNamed:  category) reject: [ :aMessageName | aMessageName = aSelector ].
	
	 ^ messageNames collect: [ :aMessageName | self perform: aMessageName ]
	

	
! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'SebastianGarbi 5/26/2013 17:35'!
oneCelsius
	^1 * TemperatureUnit celsius.! !

!MeasureTest methodsFor: 'distance measures' stamp: 'SebastianGarbi 5/25/2013 13:31'!
oneCentimeter
	^1*self centimeter.! !

!MeasureTest methodsFor: 'time measures' stamp: 'SebastianGarbi 5/26/2013 17:38'!
oneDay
	^ 1*TimeUnit day! !

!MeasureTest methodsFor: 'time measures' stamp: 'SebastianGarbi 5/26/2013 17:38'!
oneHour
	^ 1*TimeUnit hour! !

!MeasureTest methodsFor: 'distance measures' stamp: 'SebastianGarbi 5/25/2013 13:31'!
oneHundredCentimeters
	^100*self centimeter.! !

!MeasureTest methodsFor: 'compound measures' stamp: 'SebastianGarbi 5/26/2013 23:23'!
oneHundredTwentyOneMetersPerSecond
	^(121 * self meter) / self oneSecond 
	"^self error: 'este metodo debe devolver la medida 121 metro/segundo'"! !

!MeasureTest methodsFor: 'distance measures' stamp: 'SebastianGarbi 5/25/2013 13:31'!
oneMeter
	^1*self meter.! !

!MeasureTest methodsFor: 'compound measures' stamp: 'SebastianGarbi 5/26/2013 23:20'!
oneMeterPerSecond
	^1 * (self meter / self second)
"	^self error: 'este metodo debe devolver la medida 1 metro/segundo'"! !

!MeasureTest methodsFor: 'time measures' stamp: 'SebastianGarbi 5/26/2013 17:39'!
oneMinute
	^ 1 * TimeUnit minute! !

!MeasureTest methodsFor: 'time measures' stamp: 'SebastianGarbi 5/26/2013 17:39'!
oneSecond
	^ 1 *TimeUnit second.! !

!MeasureTest methodsFor: 'compound measures' stamp: 'SebastianGarbi 5/26/2013 18:13'!
oneSquaredMeter
	^1*(self meter * self meter).
! !

!MeasureTest methodsFor: 'compound measures' stamp: 'SebastianGarbi 5/26/2013 19:33'!
oneSquaredSecond
	^1*(self second * self second).
! !

!MeasureTest methodsFor: 'time units' stamp: 'SebastianGarbi 5/22/2013 18:32'!
second
	^ TimeUnit second! !

!MeasureTest methodsFor: 'time measures' stamp: 'SebastianGarbi 5/26/2013 17:39'!
sixtyMinutes
	^ 60 *TimeUnit minute.! !

!MeasureTest methodsFor: 'time measures' stamp: 'SebastianGarbi 5/26/2013 17:39'!
sixtyOneSeconds
	^61*TimeUnit second.! !

!MeasureTest methodsFor: 'time measures' stamp: 'SebastianGarbi 5/26/2013 17:39'!
sixtySeconds
	^ 60 * TimeUnit second.! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'HernanWilkinson 4/25/2011 17:28'!
temperatureExamples

	^self objectsInCategoryOf: thisContext method selector.
	
! !

!MeasureTest methodsFor: 'temperature units' stamp: 'HernanWilkinson 4/25/2011 17:28'!
temperatureUnits

	^self objectsInCategoryOf: thisContext method selector.
	
! !

!MeasureTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/25/2011 16:05'!
test01ObjectsRepresentingSameMeasureShouldBeEqual

	self assert: self oneMeter = self oneMeter.
	self assert: self oneSecond = self oneSecond.
	self assert: self oneCelsius = self oneCelsius.
	

! !

!MeasureTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/25/2011 16:06'!
test02DifferentMeasuresShouldNotBeEqual

	self deny: self oneMeter = self twoMeters.
	self deny: self oneSecond = self sixtySeconds.
	self deny: self oneCelsius = self zeroCelsius.
! !

!MeasureTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/25/2011 16:07'!
test03SameMeasureExpressWithDifferentUnitsShouldBeEqual

	self assert: self oneMeter = self oneHundredCentimeters.
	self assert: self twoMeters = self twoHundredCentimeters.
	self assert: self oneMinute = self sixtySeconds.
	self assert: self zeroCelsius = self thirtyTwoFahrenheits.
! !

!MeasureTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/25/2011 16:08'!
test03aMeasuresOfDifferentDomainShouldNotBeEqual

	self deny: self oneMeter = self oneSecond.
	self deny: self oneMeter = self oneCelsius.
	self deny: self oneCelsius = self oneSecond
! !

!MeasureTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/25/2011 16:09'!
test04EqualsShouldBeCommutative

	self assert: (self oneMeter = self oneHundredCentimeters and: [ self oneHundredCentimeters = self oneMeter ]).
	self assert: (self twoMeters = self twoHundredCentimeters and:  [ self twoHundredCentimeters = self twoMeters ]).
	self assert: (self oneMinute = self sixtySeconds and: [self sixtySeconds = self oneMinute]).
	self assert: (self zeroCelsius = self thirtyTwoFahrenheits and: [ self thirtyTwoFahrenheits = self zeroCelsius]).
! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'SebastianGarbi 5/22/2013 18:44'!
test05UnitStringRepresentationShouldBeHumanReadable

	self assert: self meter printString = 'meter'.
	self assert: self centimeter printString = 'centimeter'.
	self assert: self decimeter printString = 'decimeter'.
	self assert: self millimeter printString = 'millimeter'.
	self assert: self decameter printString = 'decameter'.
	self assert: self hectometer printString = 'hectometer'.
	self assert: self kilometer printString = 'kilometer'.	
	
	self assert: self celsius printString = 'celsius'.	
	self assert: self fahrenheit printString = 'fahrenheit'.	

	self assert: self day printString = 'day'.	
	self assert: self hour printString = 'hour'.	
	self assert: self minute printString = 'minute'.	
	self assert: self second printString = 'second'.	

! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'SebastianGarbi 5/22/2013 18:51'!
test06MeasureStringRepresentationShouldBeHumanReadable

	self assert: self oneMeter printString = '1 meter'.
	self assert: self twoMeters printString = '2 meters'.
	self assert: self oneHundredCentimeters printString = '100 centimeters'.
	
	self assert: self oneMinute printString = '1 minute'.
	self assert: self sixtySeconds printString = '60 seconds'.
	
	self assert: self zeroCelsius printString = '0 celsius'.
	self assert: self thirtyTwoFahrenheits printString = '32 fahrenheits'.
	
	
! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:14'!
test07aMeasureAmountShouldBeTheExpectedAmount

	self assert: self oneMeter amount = 1.
	self assert: self twoMeters amount = 2.
	self assert: self oneHundredCentimeters amount = 100.
	self assert: self twoHundredCentimeters amount = 200.

	self assert: self oneMinute amount = 1.
	self assert: self sixtySeconds amount = 60.
	
	self assert: self zeroCelsius amount = 0.
	self assert: self thirtyTwoFahrenheits amount = 32.
! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:15'!
test07bMeasureUnitShouldBeTheExpectedUnit

	self assert: self oneMeter unit = self meter.
	self assert: self twoMeters unit = self meter.
	self assert: self oneHundredCentimeters unit = self centimeter.
	self assert: self twoHundredCentimeters unit = self centimeter.
	
	self assert: self oneMinute unit = self minute.
	self assert: self sixtySeconds unit = self second.
	
	self assert: self zeroCelsius unit = self celsius.
	self assert: self thirtyTwoFahrenheits unit = self fahrenheit
! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:15'!
test07cDifferentMeasureUnitsShouldBeDifferent

	| unitsGroupedByItself |
	
	unitsGroupedByItself := self units groupedBy: [ :aUnit | aUnit ].
	self assert: (unitsGroupedByItself allSatisfy: [:aCollectionOfUnit | aCollectionOfUnit size = 1] )
! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:03'!
test07dDistancesCanBeConvertedToDifferentUnits

	"A partir de los test de igualdad, se deben haber dado cuenta que debemos poder
	convertir distancias a distintas unidades... y que ademas dos distancias de distintas unidades
	pueden ser iguales... Por lo tanto por qu no hacer esta caracteristica de las distancias explicita?
	Veran que luego se torna muy util
	
	Respecto de como esta escrito el test, para no tener que escribir los assert para oneMeter y oneHundredCentimeters 
	creo un array y lo recorro... Se podria escribir menos aun en este test?
	
	Y por qu se asserta sobre el amount y luego la unidad y no directametne sobre la distancia completa. ej:
	self assert: (aDistance converTo: self meter) = self oneMeter
	"
	
	(Array with: self oneMeter with: self oneHundredCentimeters) do: [ :aDistance |
		self assert: (aDistance convertTo: self meter) amount = 1.
		self assert: (aDistance convertTo: self meter) unit = self meter.
		
		self assert: (aDistance convertTo: self decimeter) amount = 10.
		self assert: (aDistance convertTo: self decimeter) unit = self decimeter.
		
		self assert: (aDistance convertTo: self centimeter) amount = 100.
		self assert: (aDistance convertTo: self centimeter) unit = self centimeter.
		
		self assert: (aDistance convertTo: self millimeter) amount = 1000.
		self assert: (aDistance convertTo: self millimeter) unit = self millimeter.
	
		self assert: (aDistance convertTo: self decameter) amount = (1/10).
		self assert: (aDistance convertTo: self decameter) unit = self decameter.
		
		self assert: (aDistance convertTo: self hectometer) amount = (1/100).
		self assert: (aDistance convertTo: self hectometer) unit = self hectometer.
	
		self assert: (aDistance convertTo: self kilometer) amount = (1/1000).
		self assert: (aDistance convertTo: self kilometer) unit = self kilometer ]! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:17'!
test07eTimeMeasuresCanBeConvertedToDifferentUnits

	self assert: (self oneMinute convertTo: self second) = self sixtySeconds.
	self assert: (self sixtySeconds convertTo: self minute) = self oneMinute.

	self assert: (self oneHour convertTo: self minute) = self sixtyMinutes.
	self assert: (self sixtyMinutes convertTo: self hour) = self oneHour.

	self assert: (self oneDay convertTo: self hour) = self twentyFourHours.
	self assert: (self twentyFourHours convertTo: self day) = self oneDay.

! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:17'!
test07fTemperatureMeasuresCanBeConvertedToDifferentUnits

	self assert: (self zeroCelsius convertTo: self fahrenheit) = self thirtyTwoFahrenheits.
	self assert: (self thirtyTwoFahrenheits convertTo: self celsius) = self zeroCelsius.

! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:19'!
test07gMeasuresCanNotBeConvertedToUnitsOfDifferentDomain

	self should: [ self oneMeter convertTo: self second ] raise: self canNotConvertMeasurementException.
	self should: [ self oneSecond convertTo: self celsius ] raise: self canNotConvertMeasurementException.
	self should: [ self oneCelsius convertTo: self centimeter ] raise: self canNotConvertMeasurementException.


! !

!MeasureTest methodsFor: '3 - Test equality - implementation details' stamp: 'HernanWilkinson 4/25/2011 16:20'!
test08aComparingMeasuresWithOtherObjectsShouldReturnFalse

	"El igual no debe generar ningun tipo de error por mas que se comparen objetos
	de distintos tipos
	Fijense como se crea una instancia de Object sin ningun tipo de problema... qu representa?"

	self deny: self oneMeter = Object new.
	self deny: Object new = self oneMeter! !

!MeasureTest methodsFor: '3 - Test equality - implementation details' stamp: 'HernanWilkinson 4/25/2011 16:21'!
test08bMeasuresThatAreEqualShouldReturnTheSameHash

	"Debido a como funcionan los diccionarios, cuando dos objetos son iguales deben
	tener es mismo hash. La inversa no es verdad"
	
	self assert: self oneMeter hash=self oneMeter hash.
	self assert: self oneMeter hash=self oneHundredCentimeters hash.
	self assert: self oneMinute hash = self sixtySeconds hash.
	self assert: self zeroCelsius hash = self thirtyTwoFahrenheits hash.
	
	
! !

!MeasureTest methodsFor: '3 - Test equality - implementation details' stamp: 'HernanWilkinson 4/25/2011 16:21'!
test08cCopiesOfTheSameMeasureShouldBeEqual

	"Dos objetos que ocupan distintas posiciones de memoria pero representan
	la misma entidad de la realidad, deben devolver true cuando se los compara por igual, puesto
	que representan la misma entidad de la realidad.
	Por lo tanto, el mensaje #= significa 'representan el mismo ente de la realidad?'
	mientras que el mensaje #== significa ocupan la misma posicion de memoria?"

	| originalOneMeter copiedOneMeter |

	"Al objeto oneMeter lo copio para asegurarme de tener uno oneMeter en otra posicion de memoria"

	originalOneMeter := self oneMeter.
	copiedOneMeter := originalOneMeter copy.

	"Me aseguro que ocupen distinta posicion de memoria"
	self deny: originalOneMeter == copiedOneMeter.

	"Ahora me aseguro que sean iguales"
	self assert: originalOneMeter = copiedOneMeter! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:31'!
test09AddingMeasuresOfSameUnitShouldReturnAMeasureRepresentingTheAddingMeasures

	self assert: (self oneMeter + self oneMeter) = self twoMeters.
	self assert: (self oneSecond + self oneSecond) = self twoSeconds.
	self assert: (self oneCelsius + self oneCelsius) = self twoCelsius.
	

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:32'!
test10AddingMeasuresOfDifferentUnitShouldReturnAMeasureRepresentingTheAddingMeasures

	self assert: (self oneMeter + self oneHundredCentimeters) = self twoMeters.
	self assert: (self oneMeter + self oneHundredCentimeters) = self twoHundredCentimeters.
	self assert: (self oneSecond + self oneMinute) = self sixtyOneSeconds.

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:48'!
test10aCanNotAddMeasuresOfDifferentDomain

	self should: [ self oneMeter + self oneSecond ] raise: self canNotConvertMeasurementException 

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:32'!
test11AddingMeasuresIsCommutative

	self assert: (self oneMeter + self twoMeters)=(self twoMeters + self oneMeter).
	self assert: (self oneSecond + self twoSeconds)=(self twoSeconds + self oneSecond).
	self assert: (self oneCelsius + self twoCelsius)=(self twoCelsius + self oneCelsius)
	


! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:33'!
test12AddingMeasuresIsAssociative

	self assert: 
		((self oneMeter + self oneMeter) + self twoMeters) = 
		(self oneMeter + (self oneMeter + self twoMeters)).

	self assert: 
		((self oneSecond + self oneSecond) + self twoSeconds) = 
		(self oneSecond + (self oneSecond + self twoSeconds)).

	self assert: 
		((self oneCelsius + self oneCelsius) + self twoCelsius) = 
		(self oneCelsius + (self oneCelsius + self twoCelsius)).

		

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:35'!
test12aAddingMeasuresKeepsMeasureImmutability

	| oneMeter oneSecond oneCelsius |
	
	oneMeter := self oneMeter.
	oneMeter + oneMeter.
	
	self assert: oneMeter = self oneMeter.
	
	oneSecond := self oneSecond.
	oneSecond + oneSecond.
	
	self assert: oneSecond = self oneSecond.
	
	oneCelsius := self oneCelsius.
	oneCelsius + oneCelsius.
	
	self assert: oneCelsius = self oneCelsius 



! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:36'!
test13aNegatingAMeasureNegatesItsAmount

	(Array with: self oneMeter with: self twoSeconds with: self thirtyTwoFahrenheits) do: [:aMeasure |
		self assert: aMeasure negated amount=aMeasure amount negated ]
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:36'!
test13bNegatingAMeasureIsReflective

	(Array with: self oneMeter with: self twoSeconds with: self thirtyTwoFahrenheits) do: [:aMeasure |
		self assert: aMeasure negated negated=aMeasure ].
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:37'!
test14SubtractingMeasuresOfSameUnitShouldReturnAMeasureRepresentingTheSubtractedMeasures

	self assert: (self twoMeters - self oneMeter) = self oneMeter.
	self assert: (self oneMeter - self oneMeter) = self zeroMeters.
	self assert: (self oneMeter - self twoMeters) = self oneMeter negated.
	
	self assert: (self twoSeconds - self oneSecond) = self oneSecond.
	self assert: (self oneSecond - self oneSecond) = self zeroSeconds.
	self assert: (self oneSecond - self twoSeconds) = self oneSecond negated.
	
	self assert: (self twoCelsius - self oneCelsius) = self oneCelsius.
	self assert: (self oneCelsius - self oneCelsius) = self zeroCelsius.
	self assert: (self oneCelsius - self twoCelsius) = self oneCelsius negated.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:38'!
test15SubtractingMeasuresOfDifferentUnitShouldReturnAMeasureRepresentingTheSubtractedMeasures

	self assert: (self twoMeters - self oneHundredCentimeters) = self oneMeter.
	self assert: (self oneMeter - self oneHundredCentimeters) = self zeroMeters.
	self assert: (self oneHundredCentimeters - self twoMeters) = self oneMeter negated.
	
	self assert: (self sixtyOneSeconds - self oneMinute) = self oneSecond.
	

	! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:48'!
test15aCanNotSubtractMeasuresOfDifferentDomain

	self should: [ self oneMeter - self oneSecond ] raise: self canNotConvertMeasurementException 

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:38'!
test16SubtractingMeasuresIsAssociative

	self assert: 
		((self twoMeters - self oneMeter) - self oneMeter) = 
		(self twoMeters - (self oneMeter + self oneMeter)).

	self assert: 
		((self twoSeconds - self oneSecond) - self oneSecond) = 
		(self twoSeconds - (self oneSecond + self oneSecond)).	

	

	! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:39'!
test16aSubtractingMeasuresKeepsMeasuresImmutability

	| oneMeter oneSecond oneCelsius |
	
	oneMeter := self oneMeter.
	oneMeter - oneMeter.
	
	self assert: oneMeter = self oneMeter.
	
	oneSecond := self oneSecond.
	oneSecond - oneSecond.
	
	self assert: oneSecond = self oneSecond.
	
	oneCelsius := self oneCelsius.
	oneCelsius - oneCelsius.
	
	self assert: oneCelsius = self oneCelsius 


! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:40'!
test17aMeasuresCanBeMultiplyByAnInteger

	self assert: self oneMeter * 1 = self oneMeter.
	self assert: self oneMeter * 2 = self twoMeters.
	self assert: self oneMeter * 0 = self zeroMeters.

	self assert: self oneSecond * 1 = self oneSecond.
	self assert: self oneSecond * 2 = self twoSeconds.
	self assert: self oneSecond * 0 = self zeroSeconds.

	self assert: self oneCelsius * 1 = self oneCelsius.
	self assert: self oneCelsius * 2 = self twoCelsius.
	self assert: self oneCelsius * 0 = self zeroCelsius.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:40'!
test17bMeasuresCanBeMultiplyByAFraction

	self assert: (self oneMeter * (2/3)) amount = (2/3).
	self assert: (self twoMeters * (2/3)) amount = (2 * (2/3)).

	self assert: (self oneSecond * (2/3)) amount = (2/3).
	self assert: (self twoSeconds * (2/3)) amount = (2 * (2/3)).

	self assert: (self oneCelsius * (2/3)) amount = (2/3).
	self assert: (self twoCelsius * (2/3)) amount = (2 * (2/3)).
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:41'!
test17cMeasuresCanBeMultiplyByAFloat

	self assert: (self oneMeter * 2.5) amount = 2.5.
	self assert: (self twoMeters * 2.5) amount = (2 * 2.5).

	self assert: (self oneSecond * 2.5) amount = 2.5.
	self assert: (self twoSeconds * 2.5) amount = (2 * 2.5).

	self assert: (self oneCelsius * 2.5) amount = 2.5.
	self assert: (self twoCelsius * 2.5) amount = (2 * 2.5).
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:45'!
test17dMeasuresCanBeMultiplyByAMeasureOfSameDomain

	self assert: (self oneMeter * self oneMeter) = self oneSquaredMeter.
	self assert: (self twoMeters * self twoMeters) = self fourSquaredMeters.
	self assert: (self twoMeters * self twoMeters * self twoMeters) = self eightCubicMeters.

	self assert: (self oneSecond * self oneSecond) = self oneSquaredSecond.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:53'!
test17eMeasuresCanBeMultiplyByAMeasureOfDifferentDomain

	self assert: (self oneMeter * self twoSeconds) = self twoMetersTimesSecond.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:42'!
test18MultiplicationKeepsMeasureImmutability

	| oneMeter oneSecond oneCelsius |
	
	oneMeter := self oneMeter.
	oneMeter * 2.
	
	self assert: oneMeter = self oneMeter.
	
	oneSecond := self oneSecond.
	oneSecond * 2.
	
	self assert: oneSecond = self oneSecond.
	
	oneCelsius := self oneCelsius.
	oneCelsius * 2.
	
	self assert: oneCelsius = self oneCelsius 




! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:49'!
test19aMeasuresCanBeDividedByAnInteger

	self assert: (self oneMeter / 1) = self oneMeter.
	self assert: (self twoMeters / 2) = self oneMeter.

	self assert: (self oneSecond / 1) = self oneSecond.
	self assert: (self twoSeconds / 2) = self oneSecond.

	self assert: (self oneCelsius / 1) = self oneCelsius.
	self assert: (self twoCelsius / 2) = self oneCelsius.

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:50'!
test19bMeasuresCanBeDividedByAFraction

	self assert: (self twoMeters / (1/3)) amount = 6.
	self assert: (self twoSeconds / (1/3)) amount = 6.
	self assert: (self twoCelsius / (1/3)) amount = 6.




! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:50'!
test19cMeasuresCanBeDividedByAFloat

	self assert: (self twoMeters / 2.5) amount = (2/2.5).
	self assert: (self twoSeconds / 2.5) amount = (2/2.5).
	self assert: (self twoCelsius / 2.5) amount = (2/2.5).




! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:52'!
test19dMeasuresCanBeDividedByAMeasureOfSameDomain

	self assert: (self oneMeter / self oneMeter) = 1.
	self assert: (self twoMeters / self oneMeter) = 2.
		
	self assert: (self oneSecond / self oneSecond) = 1.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'SebastianGarbi 5/26/2013 23:25'!
test19eMeasuresCanBeDividedByAMeasureOfDifferentDomain

	"self assert: (self oneMeter / self twoSeconds) = self twoMetersBySecond."
	self assert: (self twoMeters / self oneSecond) = self twoMetersBySecond.
	
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:54'!
test20DivisionKeepsMeasureImmutability

	| oneMeter oneSecond oneCelsius |
	
	oneMeter := self oneMeter.
	oneMeter / 2.
	
	self assert: oneMeter = self oneMeter.
	
	oneSecond := self oneSecond.
	oneSecond / 2.
	
	self assert: oneSecond = self oneSecond.
	
	oneCelsius := self oneCelsius.
	oneCelsius / 2.
	
	self assert: oneCelsius = self oneCelsius 


! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'efo 5/2/2011 20:56'!
test20aFinalSpeedCanBeRepresentedWithMeasures

	self assert: 
		(self finalSpeedStartingAt: self oneMeterPerSecond accelerating: self twoMetersPerSquaredSecond during: self sixtySeconds) = 
		(self oneMeterPerSecond + (self twoMetersPerSquaredSecond * self sixtySeconds)).
		
	self assert: (self finalSpeedStartingAt: self oneMeterPerSecond accelerating: self twoMetersPerSquaredSecond during: self sixtySeconds) = self oneHundredTwentyOneMetersPerSecond 
	
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 17:00'!
test20bMultiplyingANumberByAUnitReturnsAMeasure

	self assert: (1*self meter) = self oneMeter.
	self assert: (2*self second) = self twoSeconds.
! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:02'!
test21MeasuresProvideATotalOrder

	self assert: (self measureExamples allSatisfy: [ :aMeasure | aMeasure < (aMeasure + (1* aMeasure unit))])

! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:03'!
test22MeasuresCanBeComparedWithGreaterThan

	self assert: (self measureExamples allSatisfy: [ :aMeasure | (aMeasure + (1 * aMeasure unit)) > aMeasure ])
! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:04'!
test23MeasuresCanBeComparedWithLessThanOrEqual

	self assert: (self measureExamples allSatisfy: [ :aMeasure | aMeasure <= aMeasure and: [aMeasure <= (aMeasure + (1 * aMeasure unit))]])

	
! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:05'!
test24MeasuresCanBeComparedWithGreaterThanOrEqual

	self assert: (self measureExamples allSatisfy: [ :aMeasure | aMeasure >= aMeasure and: [(aMeasure + (1 * aMeasure unit)) >= aMeasure]])! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:05'!
test25MaxReturnsTheMaximumBetweenTwoMeasures

	self assert: (self twoMeters max: self oneMeter) = self twoMeters.
	self assert: (self oneMeter max: self twoMeters) = self twoMeters.

	self assert: (self twoMeters max: self oneHundredCentimeters) = self twoMeters.
	self assert: (self oneHundredCentimeters max: self twoMeters) = self twoMeters.

	
! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:05'!
test26MinReturnsTheMinimumBetweenTwoMeasures

	self assert: (self twoMeters min: self oneMeter) = self oneMeter.
	self assert: (self oneMeter min: self twoMeters) = self oneMeter.

	self assert: (self twoMeters min: self oneHundredCentimeters) = self oneHundredCentimeters.
	self assert: (self oneHundredCentimeters min: self twoMeters) = self oneHundredCentimeters.

	
! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:05'!
test27BetweenAndReturnsTrueIfAMeasureIsBetweenOtherTwoMeasures

	self assert: (self oneMeter between: self zeroMeters and: self twoMeters).
	self assert: (self oneHundredCentimeters between: self zeroMeters and: self twoMeters).
	
	self deny: (self twoMeters between: self zeroMeters and: self oneMeter).
	self deny: (self twoHundredCentimeters between: self zeroMeters and: self oneMeter).

! !

!MeasureTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/25/2011 17:09'!
test28IntervalOfMeasuresCanBeCreatedBecauseTheyDefineATotalOrder

	self assert: (self oneMeter to: self twoMeters) first=self oneMeter.
	self assert: (self oneMeter to: self twoMeters) last=self twoMeters.
	self assert: (self oneMeter to: self twoMeters) increment =self oneMeter.	

	self assert: (self oneHundredCentimeters to: self twoMeters) first=self oneMeter.
	self assert: (self oneHundredCentimeters to: self twoMeters) last=self twoMeters.
	self assert: (self oneHundredCentimeters to: self twoMeters) increment=self oneCentimeter.	
	! !

!MeasureTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/25/2011 17:16'!
test29MeasureIntervalStepCanBeAnyMeasure

	self assert: (self zeroMeters to: (self twoMeters * 2) by: self twoMeters) first=self zeroMeters.
	self assert: (self zeroMeters to: (self twoMeters * 2) by: self twoMeters) last=(self twoMeters * 2).
	self assert: (self zeroMeters to: (self twoMeters * 2) by: self twoMeters) increment=self twoMeters.

	self assert: ((self twoMeters * 2) to: self zeroMeters by: self twoMeters negated) first=(self twoMeters * 2).
	self assert: ((self twoMeters * 2) to: self zeroMeters by: self twoMeters negated) last=self zeroMeters.
	self assert: ((self twoMeters * 2) to: self zeroMeters by: self twoMeters negated) increment=self twoMeters negated

	! !

!MeasureTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/25/2011 17:17'!
test30MeasureIntervalSizeReturnsTheNumberOfMeasuresOfTheInterval

	self assert: (self zeroMeters to: (self twoMeters * 2) ) size =5.
	self assert: ((self twoMeters * 2) to: self zeroMeters by: self oneMeter negated) size =5.
! !

!MeasureTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/25/2011 17:17'!
test31MeasureIntervalCanBeEnumeratedUsingDo

	| value |
	
	value := 1.
	(self oneMeter to: (self oneMeter * 10)) do: [ :aMeasure |
		self assert: aMeasure amount = value.
		value := value + 1 ].
	
	self assert: value = 11
! !

!MeasureTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/25/2011 17:18'!
test32MeasureIntervalCanBeEnumeratedWithSpecificStep

	| value initialDistance byDistance finalDistance |
	
	initialDistance := self oneMeter.
	byDistance := self twoMeters.
	finalDistance := initialDistance * 9.
	value := initialDistance amount.
		
	(initialDistance to: finalDistance by:  byDistance) do: [ :aMeasure |
		self assert: aMeasure amount = value.
		value := value + byDistance amount ].
	
	self assert:  value = (finalDistance amount + byDistance amount)
! !

!MeasureTest methodsFor: '7 - Polymorphic zero' stamp: 'HernanWilkinson 4/25/2011 17:20'!
test33NothingOnAnyDomainAreEquals

	self assert: self zeroMeters = self zeroSeconds.
	self assert: self zeroSeconds = self zeroKelvin.
	self assert: self zeroKelvin = self zeroMeters! !

!MeasureTest methodsFor: '7 - Polymorphic zero' stamp: 'HernanWilkinson 4/25/2011 17:42'!
test34ZeroCelsiusIsNotNothingOnTemperature

	self deny: self zeroCelsius = self zeroKelvin.
	self deny: self zeroSeconds = self zeroCelsius.
! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'SebastianGarbi 5/26/2013 17:38'!
thirtyTwoFahrenheits
	^32*TemperatureUnit fahrenheit.! !

!MeasureTest methodsFor: 'time measures' stamp: 'HernanWilkinson 4/25/2011 17:29'!
timeExamples

	^self objectsInCategoryOf: thisContext method selector.
	
! !

!MeasureTest methodsFor: 'time units' stamp: 'HernanWilkinson 4/29/2011 17:10'!
timeUnits

	^self objectsInCategoryOf: thisContext method selector.
	
 ! !

!MeasureTest methodsFor: 'time measures' stamp: 'SebastianGarbi 5/26/2013 17:40'!
twentyFourHours
	^ 24 *TimeUnit hour.! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'SebastianGarbi 5/26/2013 17:38'!
twoCelsius
	^ 2*TemperatureUnit celsius.! !

!MeasureTest methodsFor: 'distance measures' stamp: 'SebastianGarbi 5/25/2013 13:32'!
twoHundredCentimeters
	^200*self centimeter.! !

!MeasureTest methodsFor: 'distance measures' stamp: 'SebastianGarbi 5/25/2013 13:32'!
twoMeters
	^2*self meter.! !

!MeasureTest methodsFor: 'compound measures' stamp: 'SebastianGarbi 5/26/2013 23:09'!
twoMetersBySecond
	^(2*self meter) / (1*self second)
	"^self error: 'este metodo debe devolver la medida 2 metros/segundo'"! !

!MeasureTest methodsFor: 'compound measures' stamp: 'SebastianGarbi 5/26/2013 23:22'!
twoMetersPerSquaredSecond
	^ self twoMeters / (self oneSecond * self oneSecond ).
	"^self error: 'este metodo debe devolver la medida 2 metros/segundoAlCuadrado'"! !

!MeasureTest methodsFor: 'compound measures' stamp: 'SebastianGarbi 5/26/2013 19:52'!
twoMetersTimesSecond
	^2*(self meter * self second).! !

!MeasureTest methodsFor: 'time measures' stamp: 'SebastianGarbi 5/26/2013 17:40'!
twoSeconds
	^ 2 * TimeUnit second.! !

!MeasureTest methodsFor: 'objects in category' stamp: 'HernanWilkinson 4/25/2011 17:34'!
units 

	^ OrderedCollection new
		addAll: self distanceUnits;
		addAll: self temperatureUnits;
		addAll: self timeUnits;
		yourself ! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'SebastianGarbi 5/26/2013 17:38'!
zeroCelsius
	^ 0 * TemperatureUnit celsius! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'SebastianGarbi 5/26/2013 17:38'!
zeroKelvin
	^ 0 * TemperatureUnit kelvin.! !

!MeasureTest methodsFor: 'distance measures' stamp: 'SebastianGarbi 5/25/2013 13:32'!
zeroMeters
	^0*self meter.! !

!MeasureTest methodsFor: 'time measures' stamp: 'SebastianGarbi 5/26/2013 17:40'!
zeroSeconds
	^ 0 * TimeUnit second.! !

Error subclass: #CanNotConvertMeasurement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

Object subclass: #MeasureInterval
	instanceVariableNames: 'interval unit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!MeasureInterval class methodsFor: 'instance-creation' stamp: 'SebastianGarbi 5/15/2013 18:17'!
newFrom: aDistance to: aDistance2 by: aDistance3  
	^ self new from: aDistance to: aDistance2 by: aDistance3.! !

!MeasureInterval methodsFor: 'accessing' stamp: 'SebastianGarbi 5/22/2013 23:48'!
by
	^self getMeasureFor: interval increment.! !

!MeasureInterval methodsFor: 'enumerating' stamp: 'SebastianGarbi 5/25/2013 13:44'!
do: aBlockClosure 
	interval do: [ :aNumber | aBlockClosure value: (self getMeasureFor: aNumber) ]! !

!MeasureInterval methodsFor: 'accessing' stamp: 'SebastianGarbi 5/22/2013 23:46'!
first
	^self from.! !

!MeasureInterval methodsFor: 'accessing' stamp: 'SebastianGarbi 5/22/2013 23:36'!
from
	^self getMeasureFor: interval first.
	"^unit class newAmount: interval first unit: unit ."! !

!MeasureInterval methodsFor: 'instance creation' stamp: 'SebastianGarbi 5/22/2013 23:31'!
from: startMeasure to: stopMeasure by: stepMeasure
	unit := stepMeasure unit.
	interval := Interval from:  (startMeasure amountInUnit: unit) to: (stopMeasure amountInUnit: unit) by: stepMeasure amount.
	^self.! !

!MeasureInterval methodsFor: 'private' stamp: 'SebastianGarbi 5/22/2013 23:40'!
getMeasureFor: aNumber
	^Measure newAmount: aNumber unit: unit.! !

!MeasureInterval methodsFor: 'accessing' stamp: 'SebastianGarbi 5/22/2013 23:48'!
increment
	^self by.! !

!MeasureInterval methodsFor: 'accessing' stamp: 'SebastianGarbi 5/22/2013 23:47'!
last
	^self to.! !

!MeasureInterval methodsFor: 'accessing' stamp: 'SebastianGarbi 5/15/2013 19:26'!
size 
	^interval size.! !

!MeasureInterval methodsFor: 'accessing' stamp: 'SebastianGarbi 5/25/2013 13:45'!
to
	^self getMeasureFor: interval last.
! !

Object subclass: #Unit
	instanceVariableNames: 'toBase fromBase'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

Unit class
	instanceVariableNames: 'toBase fromBase'!

Unit class
	instanceVariableNames: 'toBase fromBase'!

Unit subclass: #CompoundUnit
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

CompoundUnit class
	instanceVariableNames: 'units unidad1 unidad2'!

CompoundUnit class
	instanceVariableNames: 'units unidad1 unidad2'!

!CompoundUnit class methodsFor: 'instance creation' stamp: 'SebastianGarbi 5/26/2013 22:36'!
baseUnit
	^self.! !

!CompoundUnit methodsFor: 'comparing' stamp: 'SebastianGarbi 5/26/2013 22:21'!
= aUnit
	^(unidad1 = aUnit unidad1 and: unidad2 = aUnit unidad2) or: (unidad1 = aUnit unidad2 and: unidad2 = aUnit unidad1).
	! !

!CompoundUnit methodsFor: 'converting' stamp: 'SebastianGarbi 5/26/2013 22:52'!
canBeConvertedTo: aUnit
	^aUnit isKindOf: self class.! !

Unit subclass: #SingleUnit
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

SingleUnit subclass: #LinearUnit
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!LinearUnit class methodsFor: 'instance-creation' stamp: 'SebastianGarbi 5/26/2013 18:04'!
baseUnit
	^self subclassResponsibility.! !

!LinearUnit class methodsFor: 'instance-creation' stamp: 'SebastianGarbi 5/22/2013 20:38'!
newName: unString factor: unFactor constant: unaConstante
	^self newName: unString toBase: [ :aNumber| aNumber * unFactor + unaConstante] fromBase: [ :aNumber | aNumber - unaConstante / unFactor ].! !

LinearUnit subclass: #TemperatureUnit
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!TemperatureUnit class methodsFor: 'instance-creation' stamp: 'SebastianGarbi 5/22/2013 20:14'!
baseUnit
	^self celsius.! !

!TemperatureUnit class methodsFor: 'temperature units' stamp: 'SebastianGarbi 5/22/2013 21:09'!
celsius
	^ self newName: 'celsius' factor: 1 constant: 0! !

!TemperatureUnit class methodsFor: 'temperature units' stamp: 'SebastianGarbi 5/22/2013 21:09'!
fahrenheit
	^ self newName: 'fahrenheit' factor: 5 / 9 constant: -32 * 5 / 9! !

!TemperatureUnit class methodsFor: 'temperature units' stamp: 'SebastianGarbi 5/22/2013 21:09'!
kelvin
	^ self newName: 'kelvin' factor: 1 constant: 273.15! !

!TemperatureUnit class methodsFor: 'instance-creation' stamp: 'SebastianGarbi 5/25/2013 14:28'!
nothing
	^0*self kelvin.! !

SingleUnit subclass: #ScalarUnit
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

ScalarUnit subclass: #DistanceUnit
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!DistanceUnit class methodsFor: 'instance-creation' stamp: 'SebastianGarbi 5/22/2013 20:14'!
baseUnit
	^self meter.! !

!DistanceUnit class methodsFor: 'distance units' stamp: 'SebastianGarbi 5/13/2013 19:07'!
centimeter
	^self newName: 'centimeter' factor: 1/100.! !

!DistanceUnit class methodsFor: 'distance units' stamp: 'SebastianGarbi 5/13/2013 19:07'!
decameter
	^self newName: 'decameter' factor: 10.! !

!DistanceUnit class methodsFor: 'distance units' stamp: 'SebastianGarbi 5/13/2013 19:07'!
decimeter
	^self newName: 'decimeter' factor: 1/10.! !

!DistanceUnit class methodsFor: 'distance units' stamp: 'SebastianGarbi 5/13/2013 19:07'!
hectometer
	^self newName: 'hectometer' factor: 100.! !

!DistanceUnit class methodsFor: 'distance units' stamp: 'SebastianGarbi 5/13/2013 19:07'!
kilometer
	^self newName: 'kilometer' factor: 1000.! !

!DistanceUnit class methodsFor: 'distance units' stamp: 'SebastianGarbi 5/13/2013 19:07'!
meter
	^self newName: 'meter' factor: 1! !

!DistanceUnit class methodsFor: 'distance units' stamp: 'SebastianGarbi 5/13/2013 19:07'!
millimeter
	^self newName: 'millimeter' factor: 1/1000.! !

!ScalarUnit class methodsFor: 'instance-creation' stamp: 'SebastianGarbi 5/26/2013 18:04'!
baseUnit
	^self subclassResponsibility.! !

!ScalarUnit class methodsFor: 'instance-creation' stamp: 'SebastianGarbi 5/22/2013 20:43'!
newName: unString factor: unFactor
	^self newName: unString toBase: [:aNumber| aNumber*unFactor] fromBase: [:aNumber| aNumber/unFactor].! !

!ScalarUnit class methodsFor: 'instance-creation' stamp: 'SebastianGarbi 5/25/2013 14:27'!
nothing
	^0*	(self baseUnit).! !

ScalarUnit subclass: #TimeUnit
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!TimeUnit class methodsFor: 'instance-creation' stamp: 'SebastianGarbi 5/22/2013 20:14'!
baseUnit
	^self second.! !

!TimeUnit class methodsFor: 'time units' stamp: 'SebastianGarbi 5/22/2013 21:08'!
day
	^ self newName: 'day' factor: 24 * 60 * 60! !

!TimeUnit class methodsFor: 'time units' stamp: 'SebastianGarbi 5/22/2013 21:08'!
hour
	^ self newName: 'hour' factor: 60 * 60! !

!TimeUnit class methodsFor: 'time units' stamp: 'SebastianGarbi 5/22/2013 18:41'!
minute
	^ self newName: 'minute' factor: 60! !

!TimeUnit class methodsFor: 'time units' stamp: 'SebastianGarbi 5/22/2013 21:08'!
second
	^ self newName: 'second' factor: 1! !

!SingleUnit class methodsFor: 'instance-creation' stamp: 'SebastianGarbi 5/26/2013 18:04'!
baseUnit
	^self subclassResponsibility.! !

!SingleUnit class methodsFor: 'instance-creation' stamp: 'SebastianGarbi 5/26/2013 22:49'!
newName: unString toBase: aBlock fromBase: otherBlock
	^self new name: unString toBase: aBlock fromBase: otherBlock! !

!SingleUnit methodsFor: 'comparing' stamp: 'SebastianGarbi 5/26/2013 16:46'!
= unaUnidadDeMedida
	^(self name = unaUnidadDeMedida name) .
	" and: (self toBase = unaUnidadDeMedida toBase )) and: (self fromBase = unaUnidadDeMedida fromBase ) ."
	! !

!SingleUnit methodsFor: 'converting' stamp: 'SebastianGarbi 5/26/2013 18:49'!
canBeConvertedTo: aUnit
	^aUnit isKindOf: self class.! !

!SingleUnit methodsFor: 'accessing' stamp: 'SebastianGarbi 5/26/2013 16:48'!
name
	^name.! !

!SingleUnit methodsFor: 'instance creation' stamp: 'SebastianGarbi 5/26/2013 16:46'!
name: aByteString toBase: aBlockClosure fromBase: aBlockClosure3 
	name := aByteString.
	toBase := aBlockClosure.
	fromBase := aBlockClosure3.
	^self! !

!SingleUnit methodsFor: 'printing' stamp: 'SebastianGarbi 5/26/2013 16:48'!
printString
	^name.! !

!Unit class methodsFor: 'instance-creation' stamp: 'SebastianGarbi 5/26/2013 16:44'!
baseUnit
	^self subclassResponsibility.! !

!Unit class methodsFor: 'instance-creation' stamp: 'SebastianGarbi 5/26/2013 22:50'!
newToBase: aBlockClosure FromBase: aBlockClosure2 
	^self new toBase: aBlockClosure fromBase:  aBlockClosure2 .! !

!Unit class methodsFor: 'instance-creation' stamp: 'SebastianGarbi 5/25/2013 14:23'!
nothing
	self subclassResponsibility.! !

!Unit methodsFor: 'arithmetic' stamp: 'SebastianGarbi 5/26/2013 22:44'!
* aUnit
	^CompoundUnit newToBase: [:aNumber | self toBase value: (aUnit toBase value: aNumber) ] FromBase: [:aNumber | self fromBase value: (aUnit fromBase value: aNumber) ].! !

!Unit methodsFor: 'arithmetic' stamp: 'SebastianGarbi 5/26/2013 23:00'!
/ aUnit
	^CompoundUnit newToBase: [:aNumber | self toBase value: (aUnit toBase value: aNumber) ] FromBase: [:aNumber | self fromBase value: (aUnit fromBase value: aNumber) ].! !

!Unit methodsFor: 'comparing' stamp: 'SebastianGarbi 5/26/2013 16:50'!
= aUnit
	self subclassResponsibility .! !

!Unit methodsFor: 'converting' stamp: 'SebastianGarbi 5/22/2013 23:25'!
adaptToNumber: aSmallInteger andSend: aByteSymbol
	^Measure newAmount: aSmallInteger unit: self.
	! !

!Unit methodsFor: 'converting' stamp: 'SebastianGarbi 5/26/2013 18:47'!
canBeConvertedTo: aUnit
	self subclassResponsibility.! !

!Unit methodsFor: 'accessing' stamp: 'SebastianGarbi 5/26/2013 22:54'!
fromBase
	^fromBase.! !

!Unit methodsFor: 'accessing' stamp: 'SebastianGarbi 5/26/2013 22:54'!
toBase
	^toBase.! !

!Unit methodsFor: 'instance creation' stamp: 'SebastianGarbi 5/26/2013 22:51'!
toBase: aBlockClosure fromBase: aBlockClosure2 
	toBase := aBlockClosure.
	fromBase := aBlockClosure2.
	^self.
! !
